/*
 * Copyright (C) 1988, Bennet Yee.  You may freely distribute this code as long
 * as this notice is intact.  If you make any modifications in your
 * distribution, you must clearly document them.  If you distribute this code
 * or any derivative thereof, it must be given at no charge to all parties
 * on terms identical to those prescribed herein.  All distributions must
 * contain source code.
 *
 * This software is provided with absolutely no warranty.
 *
 * If you have questions, you can contact me at bsy@cs.cmu.edu
 */
#ifndef lint
	static char copyright[] = "\n\
Copyright (C) 1988, Bennet Yee.  You may freely distribute this code as long\n\
as this notice is intact.  If you make any modifications in your\n\
distribution, you must clearly document them.  If you distribute this code\n\
or any derivative thereof, it must be provided at no charge to all parties\n\
on terms identical to those prescribed herein.  All distributions must\n\
contain source code.\n\
\n\
This software is provided with absolutely no warranty.\n\
";
#endif /* lint */

#include <stdio.h>
#include <sys/file.h>
#include <sys/fcntl.h>

/* getpagesize() */
#include <sys/param.h>
#if	!defined(linux) || !defined(i386)
# include <sys/vmparam.h>
#endif

int init_global = 100;
int global;
extern char	**environ;
extern int	etext, edata;

main()
{
	char file[128];
	int stack_values;
	int mode = 0;
	int resp = 0;
	int val;
	int fd;
	int exitstat;

	printf("file? ");
	scanf("%s",file);
	printf("value of stack_values: ");
	scanf("%d",&stack_values);
	printf("value of global: ");
	scanf("%d",&global);
	printf("old value of init_global is %d.  New: ",init_global);
	scanf("%d",&init_global);
	printf("&stack_values = 0x%08lx\n",(long) &stack_values);
	printf("&global = 0x%08lx\n",(long) &global);
	printf("&init_global = 0x%08lx\n",(long) &init_global);
	printf("&environ = 0x%08lx\n",(long) &environ);
	printf("&etext = 0x%08lx\n",(long) &etext);
	printf("&edata = 0x%08lx\n",(long) &edata);
	printf("getpagesize() = 0x%08lx\n",(long) getpagesize());

	printf("restore? (0/1)");
	if (scanf("%d",&resp), resp==1) {
		fd = open(file,O_RDONLY,0);
		if (fd == -1) {
			fprintf(stderr,"no file\n");
			exit(1);
		}
		val = restore_world(fd,0);
		printf("HUH?\n");
		printf("return val is %d\n",val);
		printf("stack_values is %d\n",stack_values);
		printf("global value is %d\n",global);
		printf("init_global is %d\n",init_global);
		exitstat = 1;
	} else {
		fd = open(file,O_WRONLY|O_CREAT,0777);
		if (fd == -1) {
			fprintf(stderr,"can't write\n");
			exit(1);
		}
		printf("save mode (0/1): ");
		scanf("%d",&mode);
		val = save_world(fd,2,mode);
		printf("Done!\n");
		printf("return val is %d\n",val);
		printf("stack_values is %d\n",stack_values);
		printf("global value is %d\n",global);
		printf("init_global is %d\n",init_global);
		exitstat = 0;
	}
	printf("exitstat = %d\n",exitstat);
	fflush(stdout);
	system("printenv | more");
	exit(exitstat);
}
